\section{Related work}

The two projects that inspired this one are the Mancoosi project
lead by Di Cosmo, and the work on conflict defects (conflicting
packages) by Artho and most other members of this project proposal [1].

In the Mancoosi project (supported by the EU FP7), package upgrades
have been the focus of attention. Mancoosi aimed at making a system
upgrade transactional, allowing for upgrades to be rolled back. It also
improves upon the current state of component management and dependency
resolution.

Our recent case studies show that many conflicts can be traced to
common underlying reasons. In many cases, incomplete knowledge of
dependencies expressed by meta-data is the reason of the conflict. We
propose to replace hand-written meta-data with precise information obtained
through a systematic run-time analysis.


[1] C. Artho, K. Suzaki, R. Di Cosmo, R. Treinen, S. Zacchiroli. Why Do
Software Packages Conflict? 9th IEEE Working Conference on Mining Software
Repositories, June 2012, Zurich, Switzerland.

\section{Relation to other groups}

Treinen and Zacchiroli (PPS) are both members of the Debian project
and involved in the quality assurance effort of that project. This
will be useful to obtain inside knowledge of existing problems with
the Debian packaging system, and also to integrate the expected results
of the project into Debian.

While there is a large corpus of work on automatic testing of
software, we are not aware of any work about a systematic generation
of tests at the level of software packages.

The \texttt{piuparts} tool, which has been developed as part of the Debian
quality assurance endeavor, allows a developer to do some basic tests
of installing and deinstalling Debian packages in a virtual
environment. However, the tests done with this tools are currently
limited to some basic properties like leaving cruft after package
deinstallation, or one package hijacking files owned by a different
package.

\section{ Contribution to foster young researchers in Japan and France}

Both Cyrille Artho, the principal investigator on the Japanese side of
this collaboration, and Takashi Kitamura, are promising young researchers
whose scope of research and professional network will benefit from this
collaboration.

On the French side, Stefano Zacchiroli is a promising young researcher
(PhD in 2007). He had joined in 2008 the PPS lab as a post-doctoral
researcher on the Mancoosi project, and is associate professor (Maître
de conférences) since 2011.


\section{Expected outcome and impact in industry and society;
    perspective for the future.}

The recent case studies mentioned above have shown that hundreds of
bug reports in current Linux distributions can be directly traced to
package conflicts, or more generally to defects in package meta-data.
The expected results of this project will give the developers a better
insight into such unexpected interferences, and will provide tools
that can detect them proactively.

Component-based systems are also common in industry. Large companies
all have their own software stacks, organized as components or packages.
Likewise, automobiles are complex aggregations of many software packages
from different companies. With platforms for automobile software
(such as AUTOSAR) being standardized now, the market is more open to
various companies developing components. This in turn increases the
potential for hard-to-find conflicts, making our work important for
the future. Our work will show better ways of detecting possible problems
on such platforms, many of which are developed in Japan or France.

Because our work is applied to Free and Open Source Software (FOSS),
the outcome directly benefits millions of users world-wide. We will, of
course, release our tools as open source software, fostering
collaborative development of these tools by the global community.

